"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useAsyncMemo(factory, deps, initial) {
    if (initial === void 0) { initial = undefined; }
    var _a = react_1.useState(initial), val = _a[0], setVal = _a[1];
    react_1.useEffect(function () {
        var cancel = false;
        factory().then(function (val) {
            if (!cancel) {
                setVal(val);
            }
        });
        return function () {
            cancel = true;
        };
    }, deps);
    return val;
}
exports.useAsyncMemo = useAsyncMemo;
